    Member
 Include('shpStarClass.inc'),Once

  Map
  End

eNoTime     EQUATE(0)
eMidnight   EQUATE(1)
eNoon       EQUATE(4320001)
eDay        EQUATE(8640000)
eEndOfAM    EQUATE(eNoon - eMidnight)
eEndOfPM    EQUATE(eDay) 
eTick       Equate(1)
eSecond     Equate(100)
eMinute     Equate(6000)
eHour       Equate(360000)


shpStarClass.Construct         PROCEDURE
    CODE

!============================ 

shpStarClass.Destruct          PROCEDURE
    CODE

!============================ 

shpStarClass.MakeStarDate PROCEDURE(Long pDate,Long pTIme,*Decimal pStarDate)

  CODE
   pStarDate = pDate + (pTIme / eDay)

!============================ 

shpStarClass.StarET PROCEDURE(*Decimal pStarDateBegin,*Decimal pStarDateEnd)

Days                 Long
Difference           DECIMAL(15,8)
ET                   LONG
EndTime              LONG
BeginTime            LONG
BeginDate            LONG
EndDate              Long
Hours                USHORT
MinSec               LONG
Minutes              BYTE
Secs                 LONG
Seconds              BYTE
Hundredths           LONG
TimeString           STRING(20)
LongTimeString       STRING(60)


  CODE
 Self.ParseStarDate(pStarDateBegin,BeginDate,BeginTime)
 Self.ParseStarDate(pStarDateEnd,EndDate,EndTime)
 If BeginDate = EndDate
   Days = 0
   Hours = Self.CalcHours(BeginTime,EndTime)
   Minutes = Self.CalcMinutes(BeginTime,EndTime)
   Seconds = Self.CalcSeconds(BeginTime,EndTime)
 ELSIF EndDate >  BeginDate
   Days = EndDate - BeginDate
   !Days = Self.CalcDays (pStarDateBegin,pStarDateEnd)
   Difference = ((EndTime - 1) + (Days * eDay)) - (BeginTime - 1) + 1 
   BeginTime += BeginDate * eDay        ! one massive time number
   EndTime += EndDate * eDay
   Hours = self.CalcHours(BeginTime,EndTime)
 ! stop('altn. days calc ' & INT(Hours / 24))
   If Hours > 24                        ! subtract out whole days
     Hours -= 24 * Days
   End
   Difference = pStarDateEnd - pStarDateBegin
   Days = Int(Difference)   
   ET = (EndTime - 1) - (BeginTime - 1) + 1
   MinSec = ET % 360000
   Secs = MinSec % 6000
   Seconds = Secs / 100
   Minutes = Self.CalcMinutes(BeginTime,EndTime)!(0,Difference)
   !Seconds = Self.CalcSeconds(BeginTime,EndTime)!(0,Difference)
 End
 omit('OLDSTUFF')
 Difference = pStarDateEnd - pStarDateBegin
 Days = Int(Difference)
 !stop('diff ' & difference & ' days ' & days)
   omit('###')
 Stop(' Star Class -- Days: ' & Clip(Days) & '<13,10>Difference = ' & LEFT(Difference) & |
      '<13,10>Time portion ' & Difference - INT(Difference)  & |
      '<13,10>Difference as clock ticks: ' & (Difference - INT(Difference)) * eDay &|
      '<13,10>Difference as minutes: ' & ((Difference - INT(Difference)) * eDay) / 6000 )
      ! slight rounding errors -- MINIMUM precision in stardates is * decimal places
!   ###
! now just use base class methods for getsecs, gethours, getmin

 Difference = INT(Difference * eDay)    ! restore to Clarion Standard time
 !Hours = Int( Difference / 360000 )
 Hours = Self.CalcHours(0, Difference)  ! just testing Inheritance: and CalcHours requires two times
 Hours -= Days * 24                     ! remove "days" hours
 Minutes = self.CalcMinutes(0,Difference)
 !MinSec = Difference % 360000
 !Minutes = Int( MinSec / 6000 )
 Secs = MinSec % 6000                   ! using "old" code here
 Seconds = Secs / 100
 If BeginTime
   Hundredths = Secs % 100
 Else
   Hundredths = 0
 End
! OLDSTUFF

  ! return Timestring if return value is wanted for futher computations
  ! return LongTimeString if return value is wanted for display purposes
!TimeString = Clip(Days) & ':' & Clip(Hours) & ':' & Clip(Minutes) & ':' & Clip(Seconds) & '.' & Clip(Hundredths)
 LongTimeString = Clip(Days) & ' Days ' & Clip(Hours) & ' Hour(s) ' & Clip(Minutes) & ' minutes ' & Clip(Seconds) & '.' & Clip(Hundredths) & ' seconds'
 Return(LongTimeString)   
 
!============================ 

shpStarClass.TimeUpTime             Procedure(Real pTimeAllowed)     !,Real  
X   LONG
TMP Real(15.8)
Day Long

    CODE
 
 X = CLOCK() + (pTimeAllowed * eMinute)
 If X > eDay            ! computed time is after midnight / midnight rollover
   Day = Today() + 1
   TMP = X - eDay
 ELSE                   ! same day 
   Day = TODAY() 
   TMP = Self.CalcEndTime(pTimeAllowed)     ! call into parent class
 End 

 TMP = Day + (TMP / eDay)

 Return TMP
 
!============================ 

shpStarClass.ParseStarDate          PROCEDURE(*DECIMAL pStarDate, *LONG pDate, *LONG pTime) 

    CODE
 pDate = INT(pStarDate)
 pTime = (pStarDate - pDate) * eDay

!============================ 

shpStarClass.ParseStarDate          PROCEDURE(Real pStarDate, *LONG pDate, *LONG pTime) 

    CODE
 pDate = INT(pStarDate)
 pTime = (pStarDate - pDate) * eDay
 
!============================ 

shpStarClass.CalcDays                            Procedure(*Decimal pBeginStarDate,*Decimal pEndStarDate)     !,Long
Difference           DECIMAL(15,8)

    CODE
 Difference = pEndStarDate - pBeginStarDate
 Return Int(Difference)    

!============================ 
 
 